@echo off
setlocal ENABLEDELAYEDEXPANSION

title Jumpy Setup

if not "%context%" == "" goto proceed

:: -----------------------------------------------
:: init
:: -----------------------------------------------

cd "%~dp0"
set path=%~dp0\bin;%path%
call :loginit

:: is context installer or script?
if "%pluginsdir%" == "" (
	set context=script
	call :dirname "..\.." PMSDIR_L
) else (
	set context=installer
	call :dirname "%pluginsdir%" PMSDIR_L
)

:: try to update to latest setup before proceeding
call :shortpath "%cd%" setupdir
::call :curl http://skeptical.github.io/jumpy/setup.zip
::	call :curl http://127.0.0.1:8000/setup.zip
if errorlevel 1 goto proceed
unzip -o setup.zip -d "%setupdir%" -x setup.sh bin/unzip.exe 1>>"%log%" 2>&1
if errorlevel 1 goto proceed
call :delete "%setupdir%\setup.zip"
echo reentering... >>"%log%"
echo. >>"%log%"
call "%~0" %*
exit /b

:: -----------------------------------------------
:: ready
:: -----------------------------------------------

:proceed

set ver=2.5

if not "%attempted%" == "yes" set attempted=
set failed=
set SELFUPDATE=
if "%~1" == "--selfupdate" set SELFUPDATE=yes
call :shortpath "%PMSDIR_L%" PMSDIR

call :getPMSname "%PROFILE_PATH%"

if not "%PROFILE_PATH%" == "" if "%PMS%" == "UMS" if not "%SELFUPDATE%" == "yes" set UMSINSTALLER=yes
set PMS.conf=
set PMS.conf.new=PMS.conf.new
set python.path=
set rtmpdump.path=

set pause=yes
if "%~1" == "--nopause" set pause=

if "%UMSINSTALLER%" == "yes" if "%UMS_VERSION%" == "" (
	call :getinstallername
	call :err this installer requires UMS 2.0.1 or higher for automatic install.\n\nPlease shut down UMS and run the downloaded installer\n    !iname!\nmanually in your plugins folder.
)

if "%pluginsdir%" == "" set pluginsdir=%PMSDIR%\plugins
call :shortpath "%pluginsdir%" pluginsdir.short

:: -----------------------------------------------
:: smoke tests
:: -----------------------------------------------

:: are we admin?
:: http://stackoverflow.com/questions/4051883/batch-script-how-to-check-for-admin-rights/4054937#4054937
:: other ways: http://www.robvanderwoude.com/clevertricks.php
net session >nul 2>&1
if errorlevel 1 (set admin=) else set admin=yes

:: do we have write permission in plugins?
copy "%~0" "%pluginsdir%\~test.tmp"
if errorlevel 1 (set permission=) else set permission=yes
if exist "%pluginsdir%\~test.tmp" del /q  "%pluginsdir%\~test.tmp"

:: check our location

:: find debug.log
if exist "%PMSDIR%\debug.log" (
	set DEBUG_LOG="%PMSDIR%\debug.log"
) else if /i not "%PMSDIR_L:MLX=%" == "%PMSDIR_L%" (
	set DEBUG_LOG="%ALLUSERSPROFILE%\%PMS%-mlx\debug.log"
) else (
	set DEBUG_LOG="%ALLUSERSPROFILE%\%PMS%\debug.log"
)
if not exist %DEBUG_LOG% (
	if /i not "%PMSDIR_L:MLX=%" == "%PMSDIR_L%" (
		if exist "%ALLUSERSPROFILE%\%PMS%-mlx\default.log" set DEBUG_LOG="%ALLUSERSPROFILE%\%PMS%-mlx\default.log"
	) else (
		if exist "%ALLUSERSPROFILE%\%PMS%\default.log" set DEBUG_LOG="%ALLUSERSPROFILE%\%PMS%\default.log"
	)
)
if not exist %DEBUG_LOG% (
	call :doubleslash %DEBUG_LOG%
	set DEBUG_LOG=
	if "%context%" == "script" (
		call :warn !dblslashed! does not exist.\n\nPlease verify that\n- %PMS% has been launched at least once.\n- this script is located inside 'plugins\\jumpy\\setup'\n  in your %PMS% Program folder.\n
	) else (
		call :warn !dblslashed! does not exist.\n\nPlease verify that\n- %PMS% has been launched at least once.\n- this installer is located in your %PMS% 'plugins' folder.\n
	)
)
:: find PMS.conf
if not "%PROFILE_PATH%" == "" (
	set PMS.conf=%PROFILE_PATH%
) else (
	for /f "tokens=*" %%i in ('type %DEBUG_LOG% ^| find " Profile path: "') do call :splitprofilepath %%i
)
:: not found, assume default location
if not exist "%PMS.conf%" set PMS.conf=%ALLUSERSPROFILE%\%PMS%\%PMS%.conf
if not exist "%PMS.conf%" (
	echo %PMS.conf% does not exist >> "%log%"
	call :err can't find %PMS%.conf.\n\nPlease start up %PMS% and shut it down again to ensure that debug.log is valid.
)

call :getPMSname "%PMS.conf%"

if not exist "%log%" call :loginit

if "%admin%" == "yes" (call :ok Running as Admin
) else if "%permission%" == "yes" (call :ok Running with write permission
) else call :warn running without Administrator rights or write permission.\n         setup won't be able to install anything.\n
)

:: FIXME
if exist "%DEBUG_LOG%" (
	:: is PMS running?
	if "%admin%" == "yes" if not "%UMSINSTALLER%" == "yes" call :islocked %DEBUG_LOG%

	:: get server ip
	if "%server_ip%" == "" (
		for /f "tokens=*" %%i in ('type %DEBUG_LOG% ^| find " Using address /"') do set str=%%i
		set newstr=!str: address /=$!
		for /f "tokens=1* delims=$" %%i in ("!newstr!") do set server_ip=%%j
		for /f "tokens=1" %%i in ("!server_ip!") do set server_ip=%%i
	)
)
:: -----------------------------------------------
:: jumpy
:: -----------------------------------------------

if "%permission%" == "yes" if "%context%" == "installer" (
	cd ..\..
	if exist "%pluginsdir.short%\jumpy\win32-setup" if not exist "%pluginsdir.short%\jumpy\setup" move /y "%pluginsdir.short%\jumpy\win32-setup" "%pluginsdir.short%\jumpy\setup" 1>>"%log%" 2>&1
	xcopy /y /e . "%pluginsdir.short%\" 1>nul 2>&1
	if errorlevel 1 call :locked can't write files to "%pluginsdir%"
	move /y "%log%" %pluginsdir.short%\jumpy\setup\setup.log 1>nul 2>&1
	set log=%pluginsdir.short%\jumpy\setup\setup.log
	cd /d "%pluginsdir.short%\jumpy\setup"
	if not "%UMSINSTALLER%" == "yes" for %%i in ("%PMSDIR%\plugins\jumpy-*.jar") do if not "%%i" == "%PMSDIR%\plugins\%jumpyjar%" (
		call :log renaming %%~nxi
		move /y "%%i" "%%i.bak" 1>>"%log%" 2>&1
		if errorlevel 1 call :locked can't rename %%~nxi
	)
	if exist "%PMSDIR%\plugins\config.txt" del "%PMSDIR%\plugins\config.txt" 1>>"%log%" 2>&1
	if exist "%PMSDIR%\plugins\%jumpyjar%" call :ok %jumpyjar% is installed
)

:: -----------------------------------------------
:: settings
:: -----------------------------------------------

if "%SELFUPDATE%" == "yes" (set mode=self-update
) else if "%UMSINSTALLER%" == "yes" (set mode=ums installer
) else set mode=%context%

echo. >>"%log%"
echo jumpy win32-setup %ver% - mode: %mode% >>"%log%"
echo. >>"%log%"
call :getos
echo PMSDIR=%PMSDIR_L% >>"%log%"
echo server_ip=%server_ip% >>"%log%"
echo debug.log=%DEBUG_LOG% >>"%log%"

if exist "%PMS.conf%" (
	call :log found %PMS%.conf: %PMS.conf%
	set PMS.conf.new=%PMS.conf%.new
	copy /y "%PMS.conf%" "!PMS.conf.new!" 1>>"%log%" 2>&1
	call :getsetting python.path
	call :getsetting rtmpdump.path
	call :getsetting xbmc.path
	call :getsetting xbmc.main.path
	call :getsetting bin.path
	call :getsetting youtube-dl.lib.path
)
set tmp.conf=%PMS.conf%.tmp
echo files:>>"%log%"
dir /b>>"%log%"

if not "%bin.path%" == "" set bin.path=%bin.path:,=;%
if "%python.path%" == "" set python.path=c:\\Python27\\python.exe
call :dirname "%python.path%" PYTHONDIR
::if not "%rtmpdump.path%" == "" call :joinpath rtmpdump.path "%rtmpdump.path%" "%PMSDIR_L%"
set extrapath=%PMSDIR_L%\win32;%PYTHONDIR%;%bin.path%;%PMSDIR_L%\extras\bin
echo search path=%extrapath% >>"%log%"
set path=%extrapath%;%path%
echo. >>"%log%"

:: make sure winp dll is unpacked
:checkwinpdll
dir /b "%PMSDIR%\plugins\jumpy\lib\winp*.dll" 1>>"%log%" 2>&1
if %errorlevel% equ 0 goto winpdllok
unzip -o "%PMSDIR%\plugins\jumpy\lib\winp-1.14.jar" -d "%PMSDIR%\plugins\jumpy\lib" *.dll 1>>"%log%" 2>&1
echo. >>"%log%"
:winpdllok

:: -----------------------------------------------
:: python
:: -----------------------------------------------

call :log Checking python
python --version 1>>"%log%" 2>&1
if errorlevel 1 goto checkreg
for /f "tokens=* delims=" %%i in ('python -c "import sys,os;print os.path.dirname(os.path.abspath(sys.executable));"') do set PYTHONDIR=%%i\
::call :log %PYTHONDIR%
goto :haspython

:checkreg
call :log Checking python in registry
set hkey=hkcu
reg query %hkey%\software\Python\PythonCore\2.7\InstallPath 1>>"%log%" 2>&1
if errorlevel 1 (set hkey=hklm) else goto hasreg
reg query %hkey%\software\Python\PythonCore\2.7\InstallPath 1>>"%log%" 2>&1
if not errorlevel 1 goto hasreg

:getpython
if "%attempted%" == "yes" call :attemptfailed "problem installing python" done
set attempted=yes
if "%ProgramW6432%" == "" goto :32bit
set msi=python-2.7.6.amd64.msi
set msiurl=http://www.python.org/ftp/python/2.7.6/python-2.7.6.amd64.msi
goto installpython
:32bit
set msi=python-2.7.6.msi
set msiurl=http://www.python.org/ftp/python/2.7.6/python-2.7.6.msi
:installpython
if not exist %msi% call :curl %msiurl%
call :log Installing python 2.7
msiexec /i %msi% 1>>"%log%" 2>&1
call :cleanup %msi%
:: for some reason the installer instance's registry isn't updated
:: and 'reg query' will fail unless we launch a new process here
if "%context%" == "installer" (
	cls
	start /b /wait cmd.exe /c "%~0"
	exit /b
)
goto checkreg

:hasreg
for /F "tokens=3* skip=1" %%i in ('reg query %hkey%\software\Python\PythonCore\2.7\InstallPath /ve 2^>nul') do set PYTHONDIR=%%~i
if not exist "%PYTHONDIR%\python.exe" goto getpython
set path=%PYTHONDIR%;%path%

:haspython
"%PYTHONDIR%\python.exe" --version
if errorlevel 1 goto getpython
call :shortpath "%PYTHONDIR%\python.exe" pythonexe
call :setsetting python.path "%PYTHONDIR%\python.exe"
call :ok python is installed
echo. >>"%log%"

:: -----------------------------------------------
:: py4j
:: -----------------------------------------------

call :install_module py4j done
set attempted=

:checkpy4j
call :log Checking py4j version
set ver=0.9
for /F "tokens=*" %%i in ('%pythonexe% -c "import py4j.version;print py4j.version.__version__" 2^>nul') do set PY4J=%%~i
if "%PY4J%" == "" set PY4J=0.7
call :log %PY4J%
if not "%PY4J%" == "%ver%" if not "%attempted%" == "yes" (
	call :easy_install_module py4j
	set attempted=yes
	goto checkpy4j
) else call :warn py4j is not version %ver%
if "%PY4J%" == "%ver%" if exist "%pluginsdir%\jumpy\lib\py4j" call :cleanup "%pluginsdir%\jumpy\lib\py4j"
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: beautifulsoup4
:: -----------------------------------------------

:beautifulsoup4
call :install_module beautifulsoup4 lxml bs4
set attempted=
echo. >>"%log%"

:lxml
call :install_module "lxml==2.3" polib lxml
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: polib
:: -----------------------------------------------

:polib
call :install_module polib requests
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: requests
:: -----------------------------------------------

:requests
::call :install_module requests tornado
::set attempted=
::echo. >>"%log%"

:: -----------------------------------------------
:: tornado
:: -----------------------------------------------

:tornado
::call :install_module tornado initxbmc
::set attempted=
::echo. >>"%log%"

:: -----------------------------------------------
:: xbmc
:: -----------------------------------------------

:initxbmc
set xbmc_name=kodi

:checkxbmc
call :log Checking %xbmc_name%
"%xbmc.main.path%\%xbmc_name%.exe" --version 2>>"%log%"
if not errorlevel 1 goto hasxbmc
call :clearsetting xbmc.main.path
set xbmc.main.path=%ProgramFiles(x86)%\%xbmc_name%
echo checking "%xbmc.main.path%" 1>>"%log%" 2>&1
"%xbmc.main.path%\%xbmc_name%.exe" --version 2>>"%log%"
if not errorlevel 1 goto hasxbmc
set xbmc.main.path=%ProgramFiles%\%xbmc_name%
echo checking "%xbmc.main.path%" 1>>"%log%" 2>&1
"%xbmc.main.path%\%xbmc_name%.exe" --version 2>>"%log%"
if not errorlevel 1 goto hasxbmc

::if exist "%xbmc.main.path%\%xbmc_name%.exe" goto hasxbmc
::call :clearsetting xbmc.main.path
::set xbmc.main.path=
::if exist "%ProgramFiles(x86)%\%xbmc_name%\%xbmc_name%.exe" goto hasxbmc
::if exist "%ProgramFiles%\%xbmc_name%\%xbmc_name%.exe" goto hasxbmc

set hkey=hkcu
reg query %hkey%\software\%xbmc_name% 1>>"%log%" 2>&1
if errorlevel 1 (set hkey=hklm) else goto getregxbmc
reg query %hkey%\software\%xbmc_name% 1>>"%log%" 2>&1
if errorlevel 1 goto contxbmc
:getregxbmc
for /F "tokens=3* skip=1" %%i in ('reg query %hkey%\software\%xbmc_name% /ve 2^>nul') do set XBMCDIR=%%~i
if exist "%XBMCDIR%\%xbmc_name%.exe" goto setxbmcmain
if "%xbmc_name%" == "kodi" if not "%attempted%" == "yes" (
	set xbmc_name=xbmc
	goto checkxbmc
)
:contxbmc
if "%attempted%" == "yes" call :attemptfailed "problem installing %xbmc_name%" checkrtmpdump
set attempted=yes

call :log Installing kodi
set kodi_exe=kodi-15.1-Isengard.exe
if not exist %kodi_exe% call :curl http://mirrors.kodi.tv/releases/win32/%kodi_exe%
if exist %kodi_exe% %kodi_exe%
call :cleanup %kodi_exe%
set xbmc_name=kodi
goto checkxbmc

:setxbmcmain
call :setsetting xbmc.main.path "%XBMCDIR%"

:hasxbmc
call :ok %xbmc_name% is installed
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: jumpy xbmc repo
:: -----------------------------------------------

call :log Adding jumpy repo
call: get_addondir
::if not exist "%xbmc.path%" set xbmc.path=%APPDATA%\XBMC
::set addondir=%xbmc.path%\addons
::if not exist "%addondir%" mkdir "%addondir%" 1>>"%log%" 2>&1
if exist "%addondir%" unzip -o script.module.jumpy-2.0.0.zip -d "%addondir%" 1>>"%log%" 2>&1
if exist "%addondir%" unzip -o repository.jumpy.addons-1.0.0.zip -d "%addondir%" 1>>"%log%" 2>&1
echo. >>"%log%"

:: -----------------------------------------------
:: xbmc-urlresolver
:: -----------------------------------------------

call :install_addon script.module.urlresolver script.module.urlresolver-2.9.0.zip
call :install_addon script.module.simplejson script.module.simplejson-3.3.0.zip
call :install_addon script.module.t0mm0.common script.module.t0mm0.common-2.1.1.zip
::call :install_addon script.module.addon.common script.module.addon.common-2.1.1.zip
::if exist "%addondir%" if not exist "%addondir%\script.module.addon.common\lib\addon" mkdir "%addondir%\script.module.addon.common\lib\addon" 1>>"%log%" 2>&1
::if exist "%addondir%" if not exist "%addondir%\script.module.addon.common\lib\t0mm0" mklink /d "%addondir%\script.module.addon.common\lib\t0mm0" "%addondir%\script.module.addon.common\lib\addon" 1>>"%log%" 2>&1
::call :install_addon script.module.t0mm0.common script.module.t0mm0.common-2.1.1.zip
echo. >>"%log%"

:: -----------------------------------------------
:: rtmpdump
:: -----------------------------------------------

:checkrtmpdump
call :log Checking rtmpdump
"%rtmpdump.path%" --help 2>>nul
if not errorlevel 1 goto hasrtmpdump
if "%attempted%" == "yes" call :attemptfailed "problem installing rtmpdump" checkphantomjs
set attempted=yes

call :log Installing rtmpdump
::if not exist rtmpdump.exe call :curl http://sharkhunter-shb.googlecode.com/svn/trunk/ps3mediaserver/extras/bin/rtmpdump.exe
if not exist rtmpdump-2.4.zip call :curl https://github.com/downloads/K-S-V/Scripts/rtmpdump-2.4.zip
if not exist rtmpdump.exe unzip -o rtmpdump-2.4.zip rtmpdump.exe librtmp.dll 1>>"%log%" 2>&1
move rtmpdump.exe "%PMSDIR%\win32\" 1>>"%log%" 2>&1
move librtmp.dll "%PMSDIR%\win32\" 1>>"%log%" 2>&1
set rtmpdump.path=%PMSDIR%\win32\rtmpdump.exe
call :cleanup rtmpdump-2.4.zip
goto checkrtmpdump

:hasrtmpdump
call :shortpath "%rtmpdump.path%" rtmpdump.short
for /f "tokens=*" %%i in ('%rtmpdump.short% --help 2^>^&1 ^| find "RTMPDump"') do call :log %%i
call :setsetting rtmpdump.path "%rtmpdump.short%"
call :ok rtmpdump is installed
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: phantomjs
:: -----------------------------------------------

:checkphantomjs
call :log Checking phantomjs
phantomjs --version 2>>"%log%"
if not errorlevel 1 goto hasphantomjs
..\webreader\phantomjs --version 2>>"%log%"
if not errorlevel 1 goto hasphantomjs
if "%attempted%" == "yes" call :attemptfailed "problem installing phantomjs" checkyoutube_dl
set attempted=yes

call :log Installing phantomjs
set zip=phantomjs-1.9.7-windows.zip
set folder=phantomjs-1.9.7-windows
if not exist %zip% call :curl https://bitbucket.org/ariya/phantomjs/downloads/%zip%
if not exist %folder%/phantomjs.exe unzip -o %zip% %folder%/phantomjs.exe 1>>"%log%" 2>&1
call :log Installing to "%PMSDIR%\win32\"
move %folder%\phantomjs.exe "%PMSDIR%\win32\" 1>>"%log%" 2>&1
rmdir %folder% 1>>"%log%" 2>&1
call :cleanup %zip%
goto checkphantomjs

:hasphantomjs
where phantomjs.exe 1>>"%log%" 2>&1
call :ok phantomjs is installed
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: youtube-dl
:: -----------------------------------------------

:checkyoutube_dl
call :log Checking youtube-dl

set checkver=^
import os,sys,urllib2;^
VERSION_URL = 'http://rg3.github.io/youtube-dl/update/LATEST_VERSION';^
newversion = urllib2.urlopen(VERSION_URL).read().decode('utf-8').strip();^
print newversion;sys.stdout.flush();^
os.chdir(sys.argv[1]) if os.path.exists(sys.argv[1]) else sys.exit(0);^
from version import __version__;^
print 'OK '+__version__ if newversion == __version__ else '';

::call :log python -c "%checkver%" "%youtube-dl.lib.path%"
for /f "tokens=* delims=" %%i in ('python -c "%checkver%" "%youtube-dl.lib.path%"') do set newver=%%i
if not "%newver:OK =%" == "%newver%" goto hasyoutube_dl
if "%attempted%" == "yes" call :attemptfailed "problem installing youtube-dl" checkimconvert
set attempted=yes

set pkg=youtube-dl-%newver%.tar.gz
if not exist %pkg% call :curl http://youtube-dl.org/downloads/%newver%/%pkg%
if not exist youtube-dl call :untar "%pkg%"
call :log Installing to "%PMSDIR%\win32\"
if exist "%PMSDIR%\win32\youtube_dl" call :delete "%PMSDIR%\win32\youtube_dl"
move youtube-dl\youtube_dl "%PMSDIR%\win32\" 1>>"%log%" 2>&1
call :delete youtube-dl
set youtube-dl.lib.path=%PMSDIR%\win32\youtube_dl
call :cleanup %pkg%
goto checkyoutube_dl

:hasyoutube_dl
echo %newver:OK =%
call :shortpath "%youtube-dl.lib.path%" youtube-dl.lib.path.short
call :setsetting youtube-dl.lib.path "%youtube-dl.lib.path.short%"
call :ok youtube-dl is installed
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: imagemagick convert
:: -----------------------------------------------

:checkimconvert
:: remove old binary if any
if exist "%PMSDIR%\win32\convert.exe" (
	for /f "tokens=3" %%i in ('%PMSDIR%\win32\convert.exe -version ^| find "Version"') do set v=%%i
	if not "!v!" == "6.9.2-0" call :log removing imagemagick convert !v!
	if not "!v!" == "6.9.2-0" del /f "%PMSDIR%\win32\convert.exe" 1>>"%log%" 2>&1
)

call :log Checking imagemagick convert
"%PMSDIR%\win32\convert" --version 2>>"%log%"
if not errorlevel 1 goto hasimconvert
if "%attempted%" == "yes" call :attemptfailed "problem installing imconvert" updateini
set attempted=yes

call :log Installing imagemagick convert
::set zip=ImageMagick-convert-6.8.6-8-Q16-x86-windows.zip
::set folder=ImageMagick-6.8.6-8
set zip=ImageMagick-convert-6.9.2-0-Q16-x86-windows.zip
set folder=ImageMagick-6.9.2-0
:: see also http://ftp.sunet.se/pub/multimedia/graphics/ImageMagick/binaries/
:: if not exist %zip% call :curl http://www.imagemagick.org/download/binaries/%zip%
if not exist %zip% call :curl http://downloads.sourceforge.net/project/jumpy-plugin/util/%zip%
if not exist %folder%\convert.exe unzip -o %zip% %folder%/convert.exe 1>>"%log%" 2>&1
call :log Installing to "%PMSDIR%\win32\"
move "%folder%\convert.exe" "%PMSDIR%\win32\" 1>>"%log%" 2>&1
rmdir "%folder%" 1>>"%log%" 2>&1
call :cleanup %zip%
goto checkimconvert

:hasimconvert
where convert.exe 1>>"%log%" 2>&1
call :ok imagemagick convert is installed
set attempted=
echo. >>"%log%"

:: -----------------------------------------------
:: temporary file move
:: -----------------------------------------------
:updateini
call :dirname "%PMS.conf%" profiledir
set confdir=%profiledir%\jumpy
if not exist "%confdir%" md "%confdir%"
for %%f in (jumpy.conf jumpy-scripts.ini jumpy-bookmarks.ini economist.csv guardian.csv nyt.csv) do (
	set fname=%profiledir%\%%f
	if exist "!fname!" if not exist "%confdir%\!fname!" move "!fname!" "%confdir%\" 1>>"%log%" 2>&1
)

:: -----------------------------------------------
:: update jumpy-scripts.ini
:: -----------------------------------------------

:::updateini
set ini=%confdir%\jumpy-scripts.ini
set dif=jumpy-scripts.diff
if exist "%ini%" if exist "%dif%" call :tee "%PYTHONDIR%\python.exe" quickpatch.py "%dif%" "%ini%"

:: -----------------------------------------------
:: done
:: -----------------------------------------------

:done
del "%tmp.conf%" 2>>"%log%"
if "%changed%" == "yes" call :save
call :cleanup all
call :ok done
if "%failed%" == "yes" call :failed
if not "%warnings%" == "" bg PrintColor E "%warnings%\n"
if not "%RESTARTDIR%" == "" call :restart
if "%pause%" == "yes" pause
exit

:: -----------------------------------------------
:: functions
:: -----------------------------------------------

:getinstallername
for /f %%i in ('tasklist /nh /fi "IMAGENAME eq jumpy-*"') do set iname=%%i
exit /b

:getsetting
for /f "tokens=1* delims==" %%i in ('type "%PMS.conf.new%" ^| find "%~1"') do set %~1=%%j
call :trim !%~1!
set %~1=!trimmed!
exit /b

:clearsetting
move /y "%PMS.conf.new%" "%tmp.conf%" 1>>"%log%" 2>&1
type "%tmp.conf%" | find /v "%~1" > "%PMS.conf.new%"
exit /b

:doubleslash
set dblslashed=%~1
set dblslashed=%dblslashed:\\=\%
set dblslashed=%dblslashed:\\=\%
set dblslashed=%dblslashed:\=\\%
::echo dblslashed=%dblslashed%
exit /b

:setsetting
if "%~2" == "" (
	call :warn missing setsetting param: %1
	exit /b
)
call :clearsetting %~1
call :doubleslash "%~2"
::set val=%~2
::set val=%val:\\=\%
::set val=%val:\\=\%
::set val=%val:\=\\%
::call :log setting %~1 = %val%
::echo %~1 = %val% >> "%PMS.conf.new%"
call :log setting %~1 = %dblslashed%
echo %~1 = %dblslashed% >> "%PMS.conf.new%"
set changed=yes
exit /b

:save
call :log backing up and replacing %PMS%.conf
move /y "%PMS.conf%" "%PMS.conf%.bak" 1>>"%log%" 2>&1
move /y "%PMS.conf.new%" "%PMS.conf%" 1>>"%log%" 2>&1
exit /b

:attemptfailed
call :warn %~1 \nsee %log:\=\\%
set attempted=
set failed=yes
goto :%2

:failed
if not "%~1" == "" call :log %*
if "%locked%" == "yes" call :err please shut down %PMS% before running this %context%.
if not "%admin%" == "yes" set noaccess=yes
if not "%permission%" == "yes" set noaccess=yes
if "%noaccess%" == "yes" call :err setup experienced permission errors\n       Try running setup from an Administrator account\n
call :err some items were not installed.
exit /b

:: http://stackoverflow.com/questions/10518151/how-to-check-in-command-line-if-given-file-or-directory-is-locked-that-it-is-us

:islocked
set elapsed=0
:checklocked
2>nul (
  >>"%~1" echo off
) && (echo. && exit /b) || (if not "%SELFUPDATE%" == "yes" call :locked %~nx1 is locked)
bg Print .
if %elapsed% gtr 30 exit /b
set /a elapsed += 1
call :wait 1
goto checklocked

:locked
set locked=yes
call :failed  %*
exit /b

:curl
set tmpname=%~nx1.part
call :log Downloading "%~1"
curl -k -L -# -o "%tmpname%" -f "%~1"
if errorlevel 1 echo Download error>>"%log%"
move /y "%tmpname%" "%~nx1" 1>>"%log%" 2>&1
exit /b

:untar
python -c "import tarfile;tar=tarfile.open('%~1');tar.extractall();tar.close()"
exit /b

:easy_install_module
if "%setuptools%" == "yes" goto hassetuptools
:checksetuptools
call :log Checking setuptools
if exist "%PYTHONDIR%\Scripts\easy_install.exe" goto hassetuptools
if not exist ez_setup.py call :curl http://peak.telecommunity.com/dist/ez_setup.py
call :log Installing setuptools
"%PYTHONDIR%\python.exe" ez_setup.py 1>>"%log%" 2>&1
if errorlevel 1 call :attemptfailed "problem installing setuptools" %2
call :cleanup ez_setup.py
set setuptools=yes
call :log Setuptools are installed
:hassetuptools
call :log Installing %~1
"%PYTHONDIR%\Scripts\easy_install.exe" -U %1 1>>"%log%" 2>&1
if errorlevel 1 call :attemptfailed "problem installing %1" %2
exit /b

:install_module
if "%3" == "" (set mod=%1) else set mod=%3
for /f "tokens=1 delims==" %%i in ("%~1") do set modname=%%i
call :log Checking %modname%
"%PYTHONDIR%\python.exe" -c "import %mod%" 1>>"%log%" 2>&1
if not errorlevel 1 goto hasmod
call :easy_install_module %1 %2
:hasmod
call :ok %modname% is installed
exit /b

:get_addondir
if "%addondir%" == "" (
	if not exist "%xbmc.path%" set xbmc.path=%APPDATA%\%xbmc_name%
	set addondir=!xbmc.path!\addons
)
if not exist "%addondir%" mkdir "%addondir%" 1>>"%log%" 2>&1
exit /b

:install_addon
set addon=%1
set zip=%2
call :get_addondir
if not exist "%addondir%\%addon%" (
	call :log Adding %addon%
	if not exist %zip% call :curl http://mirrors.xbmc.org/addons/gotham/%addon%/%zip%
	if not exist %zip% call :curl http://mirrors.xbmc.org/addons/helix/%addon%/%zip%
	if not exist %zip% call :curl http://mirrors.xbmc.org/addons/frodo/%addon%/%zip%
	if exist %zip% unzip -o %zip% -d "%addondir%" 1>>"%log%" 2>&1
)
exit /b

:tee
set cmd=%*
set cmd=%cmd:"=""%
for /f "tokens=*" %%l in ('"%cmd%"') do call :log %%l
exit /b

:log
echo %* 2>&1
echo %* >> "%log%"
exit /b

:trim
set trimmed=%*
exit /b

:basename
set %2=%~nx1
exit /b

:dirname
set %2=%~dp1
exit /b

:shortpath
echo %d8dot3% | findstr /i %~d1
if %errorlevel% neq 0 (
	fsutil 8dot3name query %~d1 >> "%log%"
	for /f "tokens=11 skip=2" %%i in ('fsutil 8dot3name query %~d1') do set _83=%%i
	if not "!_83!" == "enabled" call :warn 8dot3 short paths are disabled on drive %~d1\nThis may cause failures in some scripts\nTo fix this see 'Windows Short Paths' in the readme\nand rerun this %context% after fixing.
	set d8dot3=%d8dot3%%~d1
)
set %2=%~s1
exit /b

:joinpath
set %1=%~f2
if not exist "%~s2" set %1=%~3\%~2
exit /b

:splitprofilepath
set str=%*
set newstr=%str: Profile path: =$%
for /f "tokens=1* delims=$" %%i in ("%newstr%") do set PMS.conf=%%j
exit /b

:getlasttok
if "%~1" == "" exit /b
set lasttok=%1
shift
goto getlasttok

:wait
ping 1.2.3.4 -n 1 -w %~1 >nul
exit /b

:getos
set os=WIN7
ver | find "6.1" 1>>"%log%" 2>&1
if %errorlevel% equ 0 exit /b
set os=VISTA
ver | find "6.0" 1>>"%log%" 2>&1
if %errorlevel% equ 0 exit /b
set os=XP
ver | find "5.1" 1>>"%log%" 2>&1
if %errorlevel% equ 0 exit /b
set os=
exit /b

:getPMSname
if "%~1" == "" (
	if exist "%PMSDIR%\pms*.jar" (set PMS=PMS) else set PMS=UMS
) else set PMS=%~n1
exit /b

:reset
set PMS=
set context=
set pluginsdir=
set log=
::set pause=
set SELFUPDATE=
set UMSINSTALLER=
set RESTARTDIR=
set PROFILE_PATH=
::set RESTART=
exit /b

:restart
if not "%SELFUPDATE%" == "yes" exit /b
cd "%RESTARTDIR%" 1>>"%log%" 2>&1
echo starting: %RESTART% 1>>"%log%" 2>&1
echo in directory: %RESTARTDIR% 1>>"%log%" 2>&1
echo restarting %PMS%...
call :reset
start /b /i "" %RESTART%
exit /b

:delete
for %%f in (%*) do (
	if exist "%%f\" rd /s /q "%%f" 2>nul
	if exist "%%f" del "%%f" 2>nul 
)

:cleanup
if "%1" == "all" (
	if not "%remove%" == "" (
		echo removing %remove% >> "%log%"
		call :delete %remove% 1>>"%log%" 2>&1
	)
) else set remove=%remove% %*
exit /b

:loginit
if not "%admin%" == "yes" if not "%PMS.conf%" == "" (
	call :dirname "%PMS.conf%" CONFDIR
	set log=!CONFDIR!\setup.log
)
if "%log%" == "" set log=%cd%\setup.log
echo %date% %time%>"%log%"
exit /b


:: bg - see http://batch.xoo.it/t2238-BG-exe-Utility-for-Batch-Games.htm

:ok
bg PrintColor E \251 A " %*\n"
echo %* >> "%log%"
exit /b
 
:warn
bg PrintColor E "Warning: %*\n"
echo Warning: %* >> "%log%"
set warnings=%warnings%\nWarning: %*\n
exit /b
 
:err
bg PrintColor C "\nError: %*\n\n"
if exist "%log%" echo Error: %* >> "%log%"
if "%pause%" == "yes" pause
exit 1
